本文整理汇总了C++中AcDbLayerTable类的典型用法代码示例。如果您正苦于以下问题:C++ AcDbLayerTable类的具体用法?C++ AcDbLayerTable怎么用?C++ AcDbLayerTable使用的例子?那么, 这里精选的类代码示例或许可以为您提供帮助。
在下文中一共展示了AcDbLayerTable类的15个代码示例,这些例子默认根据受欢迎程度排序。您可以为喜欢或者感觉有用的代码点赞,您的评价将有助于系统推荐出更棒的C++代码示例。
示例1: acdbCurDwg
//把一层设置为OFF or ON
void CArxHelper::SetOneLayer(const TCHAR *name,int flag,bool YN)
//flag 1:isoff 2:isfrozen 3:islocked
{
AcDbLayerTable *pLayerTable;
acdbCurDwg()->getLayerTable(pLayerTable,AcDb::kForRead);
if(!pLayerTable->has(name))
{
pLayerTable->close();
return;
}
AcDbObjectId id;
pLayerTable->getAt(name,id);
AcDbLayerTableRecord *pLayerTableRecord;
acdbOpenObject(pLayerTableRecord,id,AcDb::kForWrite);
switch(flag)
{
case 1:
pLayerTableRecord->setIsOff(YN);
break;
case 2:
pLayerTableRecord->setIsFrozen(YN);
break;
case 3:
pLayerTableRecord->setIsLocked(YN);
break;
}
pLayerTableRecord->close();
pLayerTable->close();
}
示例2: acdbHostApplicationServices
bool Additional_Class::FindLayer( CString LaylerName )
{
int n = 0;//判断是否找到图层
//////////////////////////////////////////////////////////////////////////
AcDbLayerTable *pLayerTbl;
acdbHostApplicationServices()->workingDatabase()
->getSymbolTable(pLayerTbl, AcDb::kForWrite);
// 建立图层遍历器
AcDbLayerTableIterator *pLayerIterator;
pLayerTbl->newIterator(pLayerIterator);
//
AcDbLayerTableRecord *pLayerTableRcd;
ACHAR *pLtName;
ACHAR *pLtNameTT;
CString pLtNameStr;
for (; !pLayerIterator->done(); pLayerIterator->step())
{
pLayerIterator->getRecord(pLayerTableRcd, AcDb::kForWrite);
pLayerTableRcd->getName(pLtName);
pLayerTableRcd->close();
pLtNameStr = pLtName;
if (pLtNameStr == LaylerName)
{
return true;
}
else
{
free(pLtName);
}
}
return false;
}
示例3: ModifyLayerProp
void ModifyLayerProp()
{
CString strLayerName(_T("NewLayer"));
AcDbLayerTable* pLayerTbl = NULL;
acdbHostApplicationServices()->workingDatabase()->getLayerTable(pLayerTbl, AcDb::kForRead);
if (!pLayerTbl->has(strLayerName))
{
pLayerTbl->close();
acutPrintf(_T("\nNo existed layer:\"%s\"."), strLayerName);
return;
}
Acad::ErrorStatus es;
AcDbLayerTableRecord* pLayerTblRcd = NULL;
pLayerTbl->getAt(strLayerName, pLayerTblRcd, AcDb::kForWrite);
AcCmColor oldColor = pLayerTblRcd->color();
int nCurColor = oldColor.colorIndex();
int nNewColor = oldColor.colorIndex();
if (acedSetColorDialog(nNewColor, Adesk::kFalse, nCurColor))
{
AcCmColor color;
color.setColorIndex(nNewColor);
pLayerTblRcd->setColor(color);
acutPrintf(_T("\nThe color of layer:\"%s\" has modified!"), strLayerName);
}
pLayerTblRcd->close();
pLayerTbl->close();
}
示例4: acdbCurDwg
void Additional_Class::SetLayerIsOff( CString strLayerName)
{
AcDbLayerTable *pLayTbl = NULL;
acdbCurDwg()->getLayerTable(pLayTbl, AcDb::kForWrite);
if(!pLayTbl->has(strLayerName))
{
pLayTbl->close(); //该图层不存在
return;
}
AcDbLayerTableRecord *pLayTblRec = NULL;
AcDbObjectId objId;
pLayTbl->getAt(strLayerName, pLayTblRec, AcDb::kForWrite);
pLayTbl->close();
//pLayTblRec->isInUse();
if (pLayTblRec==NULL)
{
return;
}
bool tempBool = pLayTblRec->isOff();
if (tempBool == false)
{
pLayTblRec->setIsOff(true);
}
else
{
pLayTblRec->setIsOff(false);
}
pLayTblRec->close();
return;
}
示例5: GetWorkingDB
Acad::ErrorStatus TWArxLayerMan::Init()
{
AcDbDatabase* pDb = GetWorkingDB();
Acad::ErrorStatus es = Acad::eOk;
AcDbLayerTable* pLayerTb = NULL;
es = pDb->getLayerTable( pLayerTb,AcDb::kForRead );
if( pLayerTb == NULL ) return es;
pLayerTb->close();
AcDbLayerTableIterator* pIte = NULL;
es = pLayerTb->newIterator( pIte );
if( pIte == NULL ) return es;
m_vLayers.clear();
for ( pIte->start(); !pIte->done(); pIte->step())
{
AcDbObjectId Id;
es = pIte->getRecordId( Id );
if( es != Acad::eOk ) continue;
m_vLayers.push_back( Id );
}
TWFreePtr( pIte );
return es;
}
示例6: addLayer
// This function creates a new AcDbLayerTableRecord, fills
// it in, and adds it to the layer table
//
// THE FOLLOWING CODE APPEARS IN THE SDK DOCUMENT.
//
void
addLayer()
{
AcDbLayerTable *pLayerTbl;
acdbHostApplicationServices()->workingDatabase()
->getSymbolTable(pLayerTbl, AcDb::kForWrite);
if (!pLayerTbl->has(_T("ASDK_TESTLAYER"))) {
AcDbLayerTableRecord *pLayerTblRcd
= new AcDbLayerTableRecord;
pLayerTblRcd->setName(_T("ASDK_TESTLAYER"));
pLayerTblRcd->setIsFrozen(0);// layer to THAWED
pLayerTblRcd->setIsOff(0); // layer to ON
pLayerTblRcd->setVPDFLT(0); // viewport default
pLayerTblRcd->setIsLocked(0);// un-locked
AcCmColor color;
color.setColorIndex(1); // set color to red
pLayerTblRcd->setColor(color);
// For linetype, we need to provide the object ID of
// the linetype record for the linetype we want to
// use. First, we need to get the object ID.
//
AcDbLinetypeTable *pLinetypeTbl;
AcDbObjectId ltId;
acdbHostApplicationServices()->workingDatabase()
->getSymbolTable(pLinetypeTbl, AcDb::kForRead);
if ((pLinetypeTbl->getAt(_T("DASHED"), ltId))
!= Acad::eOk)
{
acutPrintf(_T("\nUnable to find DASHED")
_T(" linetype. Using CONTINUOUS"));
// CONTINUOUS is in every drawing, so use it.
//
pLinetypeTbl->getAt(_T("CONTINUOUS"), ltId);
}
pLinetypeTbl->close();
pLayerTblRcd->setLinetypeObjectId(ltId);
pLayerTbl->add(pLayerTblRcd);
pLayerTblRcd->close();
pLayerTbl->close();
} else {
pLayerTbl->close();
acutPrintf(_T("\nlayer already exists"));
}
}
示例7: acdbHostApplicationServices
void
AecUiPrEntitySet::getLockedLayers()
{
m_lockedLayerCache.setLogicalLength(0);
m_lockedLayerNames.RemoveAll();
if (m_filterLockedLayers == Adesk::kFalse)
return;
AcDbLayerTableRecord* layer;
const TCHAR* tmpName;
AcDbLayerTable* layTbl;
Acad::ErrorStatus es = acdbHostApplicationServices()->workingDatabase()->getSymbolTable(layTbl, AcDb::kForRead);
if (es == Acad::eOk) {
AcDbLayerTableIterator* tblIter;
if (layTbl->newIterator(tblIter) == Acad::eOk) {
for (; !tblIter->done(); tblIter->step()) {
es = tblIter->getRecord(layer, AcDb::kForRead);
if (es == Acad::eOk) {
if (layer->isLocked()) {
m_lockedLayerCache.append(layer->objectId());
es = layer->getName(tmpName);
if (es == Acad::eOk) {
m_lockedLayerNames.Add(tmpName);
}
else {
AEC_ASSERT(0);
m_lockedLayerNames.Add(_DNT(_T(""))); // have to keep balanced
}
}
layer->close();
}
}
delete tblIter;
}
else {
AEC_ASSERT(0);
}
layTbl->close();
}
}
示例8: CGDCH03AddLayer
//-------------------------------------------------------------------------------------------
//
// 功能: 向层表中添加记录(创建新层)
//
//
// 作者:Qin H.X.
//
// 日期:200709
//
// 历史:无
//
//----------------------------------------------------------------------------------------------
// - CGDCH03.AddLayer command (do not rename)
static void CGDCH03AddLayer(void)
{
//先声明一个空的层表指针
AcDbLayerTable *pLayerTbl;
//通过当前图形数据库获取层表对象指针
//打开层表为写入状态
acdbHostApplicationServices()->workingDatabase() ->getSymbolTable(pLayerTbl, AcDb::kForWrite);
//判断层是否已经存在
if(!pLayerTbl->has(_T("MyLayer"))) {
//新层表记录
AcDbLayerTableRecord *pLayerTblRcd= new AcDbLayerTableRecord;
pLayerTblRcd->setName(_T("MyLayer")); //设定图层名
pLayerTblRcd->setIsFrozen(0); // 图层解冻
pLayerTblRcd->setIsOff(0); // 打开图层
pLayerTblRcd->setVPDFLT(0); // 使用默认视口
pLayerTblRcd->setIsLocked(0); // 图层解锁
// AcCmColor是ACAD颜色管理类
AcCmColor color;
color.setColorIndex(1);
// 图层颜色为红色
pLayerTblRcd->setColor(color);
// 为给新图层设置线型,要得到线型表记录的ID。
// 以下的代码演示如何得到并操作记录ID
AcDbLinetypeTable *pLinetypeTbl;
AcDbObjectId ltId;
acdbHostApplicationServices()->workingDatabase()->getSymbolTable(pLinetypeTbl, AcDb::kForRead);
if ((pLinetypeTbl->getAt(_T("DASHED"), ltId))!= Acad::eOk) {
acutPrintf(_T("\n未发现DASHED线型使用CONTINUOUS线型"));
// 每一个不完全空的图形数据库的线型表中都有线型名为CONTINUOUS 的默认记录
pLinetypeTbl->getAt(_T("CONTINUOUS"), ltId);
}
pLinetypeTbl->close();
pLayerTblRcd->setLinetypeObjectId(ltId);
pLayerTbl->add(pLayerTblRcd);
pLayerTblRcd->close();
pLayerTbl->close();
} else {
pLayerTbl->close();
acutPrintf(_T("\n层已经存在"));
}
}
示例9: acdbHostApplicationServices
void CLayerTreeDlg::OnTvSelChanged(NMHDR* pNMHDR)
{
NM_TREEVIEW* pNMTreeView = (NM_TREEVIEW*)pNMHDR;
// TODO: Add your control notification handler code here
TV_ITEM tvi = pNMTreeView->itemNew;
HTREEITEM hItem = tvi.hItem;
if(m_tree.ItemHasChildren(hItem))
{
return;
}
CString strLayerName = m_tree.GetItemText(hItem);
Acad::ErrorStatus es = Acad::eOk;
AcDbDatabase* pDB = acdbHostApplicationServices()->workingDatabase();
if (NULL == pDB)
return;
AcDbLayerTable *pLyTable = NULL;
AcDbLayerTableRecord *pLyRcd = NULL;
es = pDB->getSymbolTable(pLyTable,AcDb::kForRead); //获得当前数据库中层表指针
if ( es != Acad::eOk )
{
acutPrintf("\n获取LayerTable的时候发生错误,请稍后再试。\n");
return;
}
if ( !pLyTable->has(strLayerName) )
{
pLyTable->close();
return;
}
pLyTable->close();
SetCurrentLayer(strLayerName);
}
示例10: memorize
// 現在の状態を覚える
bool CAllLayerState::memorize(AcDbDatabase* pDb)
{
// レイヤテーブルの取得
AcDbLayerTable* pLayerTable = NULL;
if (pDb->getLayerTable(pLayerTable, AcDb::kForRead) != Acad::eOk)
return false;
AcDbLayerTableIterator* pIter;
pLayerTable->newIterator(pIter);
for (; !pIter->done(); pIter->step()) {
// レイヤを取得
AcDbObjectId idLayer;
pIter->getRecordId(idLayer);
CLayerState layerstate(idLayer);
push_back(layerstate);
}
delete pIter;
// 閉じとく
pLayerTable->close();
return true;
}
示例11: ShowLayer
void CLayerTreeDlg::ShowLayer(HTREEITEM hItem, BOOL bShow)
{
CString sLayerName = m_tree.GetItemText(hItem);
HTREEITEM hChild = m_tree.GetNextItem(hItem,TVGN_CHILD);
// 只有树叶才有对应的图层
if (hChild == NULL)
{
ShowLayer(sLayerName, bShow);
//如果是面层,还要把它的填充图层打开
CString sHatchLayer;
sHatchLayer.Format("%s_填充",sLayerName);
bool hasHatch = false;
acDocManager->lockDocument(acDocManager->curDocument());
AcDbLayerTable * pLayerTbl = NULL;
Acad::ErrorStatus es =
acdbHostApplicationServices()->workingDatabase()->getSymbolTable(pLayerTbl,AcDb::kForRead);
if (pLayerTbl->has(sHatchLayer))
{
AcDbLayerTableRecord * pLayerTbRcd = NULL;
es = pLayerTbl->getAt(sHatchLayer,pLayerTbRcd,AcDb::kForWrite);
pLayerTbRcd->setIsOff(bShow == 0);
pLayerTbRcd->close();
hasHatch = true;
}
pLayerTbl->close();
acDocManager->unlockDocument(acDocManager->curDocument());
}
while(hChild != NULL)
{
ShowLayer(hChild, bShow);
hChild = m_tree.GetNextItem(hChild,TVGN_NEXT);
}
}
示例12: ASSERT
Acad::ErrorStatus
ArxDbgUtils::addNewLayer(LPCTSTR layerName, AcDbDatabase* db)
{
ASSERT(db != NULL);
// if layer already exists, then just return
AcDbLayerTable* layTbl;
Acad::ErrorStatus es = db->getSymbolTable(layTbl, AcDb::kForRead);
if (es != Acad::eOk)
return es;
if (layTbl->has(layerName)) {
layTbl->close();
return Acad::eOk;
}
// upgrade to write
es = layTbl->upgradeOpen();
if (es != Acad::eOk) {
ASSERT(0);
layTbl->close();
return es;
}
// make sure the name gets set ok
AcDbLayerTableRecord* newRec = new AcDbLayerTableRecord;
es = newRec->setName(layerName);
if (es != Acad::eOk) {
delete newRec;
layTbl->close();
return Acad::eInvalidInput;
}
// look up value for default linetype CONTINUOUS,
// AcDbLayerTableRecord doesn't set this automatically (at least it didn't in Sedona)
newRec->setLinetypeObjectId(db->continuousLinetype());
es = layTbl->add(newRec);
if (es != Acad::eOk)
delete newRec;
else
newRec->close();
layTbl->close();
return es;
}
示例13: CheakLayerExit
static void CheakLayerExit(CString layerName,int colorIndx, AcDb::LineWeight lineWeigt)
{
//int colorIndx = 7; //默认的颜色为白色
//AcDb::LineWeight lineWeigt = AcDb::kLnWt000;
//lineWeigt = AcDb::kLnWt030;
AcDbLayerTable* pLayerTbl = NULL;
// 获取当前的数据库
AcDbDatabase*pDB=acdbHostApplicationServices()->workingDatabase();
// 因为要创建新的图层,所以先要以写的方式获取图层表
pDB->getSymbolTable(pLayerTbl,AcDb::kForWrite);
// 检查图层是否存在
if (!pLayerTbl->has(layerName)) {
// 初始化一个新的对象,并且设置它的属性
AcDbLayerTableRecord *pLayerTblRcd = new AcDbLayerTableRecord;
pLayerTblRcd->setName(layerName);
pLayerTblRcd->setIsFrozen(0); // 图层设置为THAWED(解冻的)
pLayerTblRcd->setIsOff(0); // 图层设置为ON(开着的)
pLayerTblRcd->setIsLocked(0); // 图层 un-locked(解锁的)
AcCmColor color;
color.setColorIndex(colorIndx); // 图层的颜色设置
pLayerTblRcd->setColor(color);
pLayerTblRcd->setLineWeight(lineWeigt);
// 增加一个新的图层到容器(表)中
pLayerTbl->add(pLayerTblRcd);
// 把新建的图层关闭(不要删除它)
pLayerTblRcd->close();
// 关闭容器(表)
pLayerTbl->close();
}
else {
// 如果这个图层已经存在,仅仅需要关闭表继续就是
AcDbLayerTableRecord *pLayerTblRcd;
pLayerTbl->getAt(layerName, pLayerTblRcd, AcDb::kForWrite);
AcCmColor color;
color.setColorIndex(colorIndx); // 图层的颜色设置
pLayerTblRcd->setColor(color);
pLayerTblRcd->setLineWeight(lineWeigt);
pLayerTblRcd->close();
pLayerTbl->close();
//acutPrintf(_T("\nMYLAYER already exists"));
}
}
示例14: Get_LayerLW
bool Additional_Class::Get_LayerLW( CString LayerName, double &Length, double &Width )
{
AcDbLayerTable *pLayerTbl = NULL;
acdbHostApplicationServices()->workingDatabase()->getSymbolTable(pLayerTbl,AcDb::kForRead);
if (!pLayerTbl->has(LayerName))
{
//acutPrintf("\n木有%s层!", LayerName);
//SetError("THERE ISN`T"+LayerName+"LATYER!", "Get_LayerLW");
pLayerTbl->close();
return false;
}
AcDbObjectId layerId;
pLayerTbl->getAt(LayerName, layerId);
pLayerTbl->close();
AcDbBlockTable *pBlkTbl = NULL;
////获得当前数据库块表
acdbHostApplicationServices()->workingDatabase()->getBlockTable(pBlkTbl,AcDb::kForWrite);
////获得模型空间块表记录
AcDbBlockTableRecord *pBlkTblRcd = NULL;
pBlkTbl->getAt(ACDB_MODEL_SPACE, pBlkTblRcd, AcDb::kForRead);
pBlkTbl->close();
////创建块表记录遍历器
AcDbBlockTableRecordIterator *pltr;
pBlkTblRcd->newIterator(pltr);
AcDbEntity *pEnt;
//AcDbEntityPointer pEnt_Ptr;
////AcDbObjectPointer<AcDbPolyline> pPolyLine_Ptr;
AcDbPolyline *pPolyLine = NULL;
AcDbObjectIdArray PolyLineID_List;
for (pltr->start(); !pltr->done(); pltr->step())
{
pltr->getEntity(pEnt, AcDb::kForRead);
// //pEnt_Ptr.acquire(pEnt);
if (pEnt->layerId()==layerId)
{
if (pEnt->isKindOf(AcDbPolyline::desc()))
{
pPolyLine = AcDbPolyline::cast(pEnt);
if (pPolyLine != NULL)
{
if (PolyLineIfRectangle(pPolyLine)==true)
{
PolyLineID_List.append(pPolyLine->objectId());
}
}
}
}
}
if (PolyLineID_List.length() >1)
{
acutPrintf(_T("Bom Error 1002\n"));// 有很多矩形
delete pltr;
pEnt->close();
pPolyLine->close();
pBlkTblRcd->close();
return false;
}
////pPolyLine.open(PolyLineID_List[0], AcDb::kForRead);
acdbOpenAcDbEntity(pEnt,PolyLineID_List[0], AcDb::kForRead); //error!
pPolyLine = AcDbPolyline::cast(pEnt);
Get_RectangleLW(pPolyLine, Length, Width);
pBlkTblRcd->close();
pPolyLine->close();
pEnt->close();
delete pltr;
return true;
}
示例15: bool
bool Additional_Class::LaylerFilter( AcDbObjectIdArray &EntityID, bool(*Filter)(AcDbEntity*, AcDbObjectId&) )
{
// 遍历所有图层符合规则的实体返回ID列表
bool RunState = false;
AcDbObjectIdArray LayerID_Array;
vector<CString> LayerName_Array;
AcDbObjectIdArray tempIDList;
AcDbLayerTable *pLayerTbl;
AcDbLayerTableRecord *pLayerTblRcd;
acdbHostApplicationServices()->workingDatabase()->getLayerTable(pLayerTbl,AcDb::kForWrite);
AcDbLayerTableIterator *pltr;
pLayerTbl->newIterator(pltr); // 图层遍历器
ACHAR *layerName;
for (pltr->start(); !pltr->done(); pltr->step())
{
pltr->getRecord(pLayerTblRcd,AcDb::kForRead);
pLayerTblRcd->getName(layerName); // 得到图层名称
LayerName_Array.push_back(layerName);
//pLayerTbl->getAt(layerName,layerId); // 得到图层ID
//LayerID_Array.append(layerId); // 得到所有图层的ID列表
}
pLayerTbl->close();
pLayerTblRcd->close();
// 对每层实体进行遍历
for (int i=0; i<LayerName_Array.size(); i++)
{
RunState = LaylerFilter(LayerName_Array.at(i), EntityID, Filter);
}
//for (pltr->start(); !pltr->done(); pltr->step())
//{
// // 遍历所有图层开始
// pltr->getRecord(pLayerTblRcd,AcDb::kForRead);
// pLayerTblRcd->getName(layerName); // 得到图层名称
// pLayerTbl->getAt(layerName,layerId);
// for (pltrX->start(); !pltrX->done(); pltrX->step())
// {
// if(Acad::eOk ==pltrX->getEntity(pEnt, AcDb::kForRead, false))
// {
// if (200>Check_Entity(pEnt)>=100)
// {
// temp_layerId = pEnt->layerId();
// if (temp_layerId == layerId)
// {
// entityID = pEnt->objectId();
// if (Filter(pEnt, entityID) == true)
// {
// EntityID.append(entityID);
// }
// }
// }
// }
// }
//
// //RunState = LaylerFilter(layerName, tempIDList, Filter);
// //if (RunState == true)
// //{
// // for (int j = 0; j<tempIDList.length(); j++)
// // {
// // EntityID.append(tempIDList[j]);
// // }
// //}
//}
//pLayerTblRcd->close();
//pLayerTbl->close();
//pBlkTbl->close();
//pBlkTblRcd->close();
delete pltr;
return false;
}